pub use monostate::MustBe;

pub use common::{
    derive_more::{Deref, DerefMut},
    eyre::{bail, Result},
    itertools::Itertools,
    serde::{self, Deserialize, Serialize},
    serde_json,
    serde_with::skip_serializing_none,
    smart_default::SmartDefault,
    strum::Display,
};

pub use codec_html_trait::HtmlCodec;
pub use codec_jats_trait::JatsCodec;
pub use codec_losses::Losses;
pub use codec_markdown_trait::{MarkdownCodec, MarkdownEncodeContext};
pub use codec_text_trait::TextCodec;
pub use node_store::{ReadNode, WriteNode};
pub use node_strip::StripNode;

#[cfg(feature = "proptest")]
pub use crate::proptests::*;
